#!/usr/bin/env node

require("dotenvrc");
const AWS = require("aws-sdk");

const lambdaPublish = require("./lambda-publish");
const lambda = new AWS.Lambda();

/* 파라미터 정리 */ {
  const runtime_node = process.argv.shift();
  const executed_file = process.argv.shift();
}

/* AWS 파라미터 체크*/ {
  const keys = [
    "AWS_ACCESS_KEY_ID",
    "AWS_SECRET_ACCESS_KEY",
    "AWS_REGION",
    "AWS_DEFAULT_REGION",
  ];
  for (let i = 0; i < keys.length; i++) {
    if (!process.env[keys[i]]) {
      throw new Error([`다음 키가 없습니다.`, `${keys[i]}`].join("\n"));
    }
  }
}

(async function () {
  const params = process.argv;
  const { mode, target, layer_list } = lambdaPublish.validatorParams(params);

  if (mode === "lambda") {
    const is_exist = await lambdaPublish.P((resolve) =>
      lambda.getFunction({ FunctionName: target }, (e, d) => resolve(!!d))
    );
    if (is_exist) {
      // update
    } else {
      // create
      const role = await lambdaPublish.createRole(target);
      const a = await lambdaPublish.createFunction(
        target,
        target,
        role.Role.Arn
      );
      console.log({ a });
    }
  } else {
    const is_exist = await lambdaPublish.P((resolve) =>
      lambda.getFunction({ FunctionName: target }, (e, d) => resolve(!!d))
    );
    if (is_exist) {
      //update
    } else {
      //create
      const a = await lambdaPublish.createLayer(target, target);
      console.log({ a });
    }
  }
})();
